#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <string.h>
#include <unistd.h>
#include <glib.h>
#include <stdarg.h>
#include <libxml/parser.h>
#include <libxml/parserInternals.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>
#include "xmltools.h"
#include "users_xml.h"
#include "hl_locks.h"

#ifdef HAVE_LIBDMALLOCTH
#include <dmalloc.h>    /* Gray Watson's library */
#define show_alloc() dmalloc_log_unfreed()
#define show_stats() dmalloc_log_stats()
#else
#define show_alloc()    /* nothing */
#define show_stats()    /* nothing */
#endif

void display_nick_privilege(xmlNodePtr user) {
	xmlChar *privilege;
	privilege = xmlGetProp(user, "privilege");
	printf("nick: %s\tprivilege:%s\n", user->children->content,privilege);
	xmlFree(privilege);
}

void display_all_nick_matching(xmlXPathObjectPtr result) {
	xmlNodeSetPtr nodeset;
	int i;
	
	nodeset = result->nodesetval;
	for (i=0; i < nodeset->nodeNr; i++) {
		display_nick_privilege(nodeset->nodeTab[i]);
	}
}

int main()  {
	initXMLTools();
	{
		int i;
		char *passwd=NULL;
		int level;
		gboolean unkickable;
		char *comment=NULL;
		
		for(i=0;i<1;i++) {
			printf("I=%d\n",i);
			if (xml_get_user("JrCs", &level, &passwd, &unkickable, &comment)) {
				printf("User JrCs Found Level:[%d] Password:[%s] Unkickable:[%d] Comment:[%s]\n",level,passwd,unkickable,comment);
				free(passwd);
				free(comment);
			}
			sleep(2);
		}
	}

	printf("Level for KICK:[%d]\n",get_access_level("KICK"));
	sleep(1);
	printf("Level for TOTO:[%d]\n",get_access_level("TOTO"));
	sleep(1);
	
	if (xml_add_user("Toto", 3, "test~", TRUE, "Salut avec des > et des \""))
		printf("Add user OK\n");
		
	xml_dump_users("-");

	sleep(2);

	if (xml_del_user("JrCs"))
		printf("Del user OK\n");
		
	xml_dump_users("-");
	
	
    //HL_LOCK_WRITE(users_xml_file);
	//user_doc = loadXMLFile(xml_file);
	//HL_UNLOCK_WRITE(users_xml_file);
	//
	//printf("----------------------------------\nWalking the tree:\n");
	//HL_LOCK_READ(users_xml_file);
	//cur = xmlDocGetRootElement(user_doc);
	//cur=cur->children;
	//while (cur != NULL && (xmlStrcmp(cur->name, (const xmlChar *) "users"))) {
	//	cur=cur->next;
	//}	
	//if (cur == NULL) {
	//	fprintf(stderr,"Can't find users in the document\n");
	//	xmlFreeDoc(user_doc);
	//	return 0;
	//}
	//cur=cur->children;
	//if (xmlStrcmp(cur->name, (const xmlChar *) "nick")) {
	//	fprintf(stderr,"Wrong document\n");
	//	xmlFreeDoc(user_doc);
	//	return 0;
	//}
	//					   
	//{
	//	xmlChar *privilege;
	//	while (cur != NULL) {
	//		if (!xmlStrcmp(cur->name, (const xmlChar *) "nick")) {	
	//			privilege = xmlGetProp(cur, "privilege");
	//			printf ("Name:%s\tPrivilege:%s\n",cur->children->content,privilege);
	//			xmlFree(privilege);
	//		}
	//		cur=cur->next;
	//	}
	//}
	//HL_UNLOCK_READ(users_xml_file);
	//
	//printf("----------------------------------\nUsing XPATH:\n");
	//{
	//	xmlChar *xpath = "//users/nick"; /* retrieve all the nick */
	//	xmlXPathObjectPtr result;
	//	
	//	result = getnodeset (user_doc, xpath);
	//	if (result) {
	//		display_all_nick_matching(result);
	//		xmlXPathFreeObject(result);
	//	}
	//}
	//
	//
	//printf("----------------------------------\nAll master using XPATH:\n");
	//{
	//	xmlChar *xpath = "///users/nick[@privilege=\"master\"]"; /* retrieve all master */
	//	xmlXPathObjectPtr result;
	//	
	//	result = getnodeset (user_doc, xpath);
	//	if (result) {
	//		display_all_nick_matching(result);
	//		xmlXPathFreeObject(result);
	//	}
	//}
	//
	//printf("----------------------------------\nFind a particular user using XPATH:\n");
	//{
	//	xmlNodePtr user=find_user(user_doc,"flex>bison"); /* nick with reserved caractere */
	//	if (user) {
	//		display_nick_privilege(user);
	//	}
	//}
	//
	//printf("----------------------------------\n");
    //cur = xmlDocGetRootElement(user_doc)->children;
	//xmlNewChild(cur, NULL, "nick", "new>user");
	//
	//xmlSaveFormatFile("-", user_doc,1); 
	//
	//xmlFreeDoc(user_doc);
	//xmlCleanupParser();

	xml_free_users_resource();
	xmlCleanupParser();
	return 0;
}
